Index: trunk/SophyaLib/HiStats/hbook.h
===================================================================
--- trunk/SophyaLib/HiStats/hbook.h	(revision 1089)
+++ trunk/SophyaLib/HiStats/hbook.h	(revision 1092)
@@ -9,70 +9,70 @@
 #endif
 
-void hbandx_(int_4 *,float *,float *,float *);
-void hbandy_(int_4 *,float *,float *,float *);
+void hbandx_(int_4 *,r_4 *,r_4 *,r_4 *);
+void hbandy_(int_4 *,r_4 *,r_4 *,r_4 *);
 
 void hbarx_(int_4 *);
 void hbary_(int_4 *);
 
-void hbfun1_(int_4 *,char *,int_4 *,float *,float *,float fun(float *),int_4);
-void hbfun2_(int_4 *,char *,int_4 *,float *,float *,int_4 *,float *,float *
-            ,float fun(float *,float *),int_4);
+void hbfun1_(int_4 *,char *,int_4 *,r_4 *,r_4 *,r_4 fun(r_4 *),int_4);
+void hbfun2_(int_4 *,char *,int_4 *,r_4 *,r_4 *,int_4 *,r_4 *,r_4 *
+            ,r_4 fun(r_4 *,r_4 *),int_4);
 void hbigbi_(int_4 *,int_4 *);
-void hbook1_(int_4 *,char *,int_4 *,float *,float *,float *,int_4);
-void hbook2_(int_4 *,char *,int_4 *,float *,float *
-            ,int_4 *,float *,float *,float *,int_4);
-void hbpro_(int_4 *,float *);
-void hbprof_(int_4 *,char *,int_4 *,float *,float *
-            ,float *,float *,char *,int_4,int_4);
-void hbprox_(int_4 *,float *);
-void hbproy_(int_4 *,float *);
-void hbslix_(int_4 *,int_4 *,float *);
-void hbsliy_(int_4 *,int_4 *,float *);
+void hbook1_(int_4 *,char *,int_4 *,r_4 *,r_4 *,r_4 *,int_4);
+void hbook2_(int_4 *,char *,int_4 *,r_4 *,r_4 *
+            ,int_4 *,r_4 *,r_4 *,r_4 *,int_4);
+void hbpro_(int_4 *,r_4 *);
+void hbprof_(int_4 *,char *,int_4 *,r_4 *,r_4 *
+            ,r_4 *,r_4 *,char *,int_4,int_4);
+void hbprox_(int_4 *,r_4 *);
+void hbproy_(int_4 *,r_4 *);
+void hbslix_(int_4 *,int_4 *,r_4 *);
+void hbsliy_(int_4 *,int_4 *,r_4 *);
 void hcdir_(char *,char *,int_4,int_4);
 void hdelet_(int_4 *);
-void hfill_(int_4 *,float *,float *,float *);
-void hfithn_(int_4 *,char *,char *,int_4 *,float *
-            ,float *,float *,float *,float *,float *,int_4,int_4);
-void hfn_(int_4 *,float *);
-void hfunc_(int_4 *,float fun(float *));
-void hgive_(int_4 *,char *,int_4 *,float *,float *
-                          ,int_4 *,float *,float *,int_4 *,int_4 *);
-void hgn_(int_4 *,int_4 *,int_4 *,float *,int_4 *);
-void hgnf_(int_4 *,int_4 *,float *,int_4 *);
+void hfill_(int_4 *,r_4 *,r_4 *,r_4 *);
+void hfithn_(int_4 *,char *,char *,int_4 *,r_4 *
+            ,r_4 *,r_4 *,r_4 *,r_4 *,r_4 *,int_4,int_4);
+void hfn_(int_4 *,r_4 *);
+void hfunc_(int_4 *,r_4 fun(r_4 *));
+void hgive_(int_4 *,char *,int_4 *,r_4 *,r_4 *
+                          ,int_4 *,r_4 *,r_4 *,int_4 *,int_4 *);
+void hgn_(int_4 *,int_4 *,int_4 *,r_4 *,int_4 *);
+void hgnf_(int_4 *,int_4 *,r_4 *,int_4 *);
 void hgnpar_(int_4 *,char *,int_4);
-float hi_(int_4 *,int_4 *);
+r_4 hi_(int_4 *,int_4 *);
 void hidopt_(int_4 *,char *,int_4);
-float hie_(int_4 *,int_4 *);
-float hif_(int_4 *,int_4 *);
-float hij_(int_4 *,int_4 *,int_4 *);
-void hijxy_(int_4 *,int_4 *,int_4 *,float *,float *);
-void hix_(int_4 *,int_4 *,float *);
+r_4 hie_(int_4 *,int_4 *);
+r_4 hif_(int_4 *,int_4 *);
+r_4 hij_(int_4 *,int_4 *,int_4 *);
+void hijxy_(int_4 *,int_4 *,int_4 *,r_4 *,r_4 *);
+void hix_(int_4 *,int_4 *,r_4 *);
 void hldir_(char *,char *,int_4,int_4);
 void hmdir_(char *,char *,int_4,int_4);
-float hmax_(int_4 *);
-void hmaxim_(int_4 *,float *);
-float hmin_(int_4 *);
-void hminim_(int_4 *,float *);
-void hnorma_(int_4 *,float *);
+r_4 hmax_(int_4 *);
+void hmaxim_(int_4 *,r_4 *);
+r_4 hmin_(int_4 *);
+void hminim_(int_4 *,r_4 *);
+void hnorma_(int_4 *,r_4 *);
 void hnoent_(int_4 *,int_4 *);
-void hpak_(int_4 *,float *);
-void hpake_(int_4 *,float *);
+void hpak_(int_4 *,r_4 *);
+void hpake_(int_4 *,r_4 *);
 void hprint_(int_4 *);
 void hrend_(char *,int_4);
 void hrin_(int_4 *,int_4 *,int_4 *);
-float hrndm1_(int_4 *);
-void hrndm2_(int_4 *,float *,float *);
+r_4 hrndm1_(int_4 *);
+void hrndm2_(int_4 *,r_4 *,r_4 *);
 void hropen_(int_4 *,char *,char *,char *,int_4 *,int_4 *,int_4,int_4,int_4);
 void hrout_(int_4 *,int_4 *,char *,int_4);
-void hscale_(int_4 *,float *);
-float hstati_(int_4 *,int_4 *,char *,int_4 *,int_4);
-float hsum_(int_4 *);
-void hunpak_(int_4 *,float *,char *,int_4 *,int_4);
-void hunpke_(int_4 *,float *,char *,int_4 *,int_4);
-float hx_(int_4 *,float *);
-float hxe_(int_4 *,float *);
-float hxi_(int_4 *,float *,int_4 *);
-float hxyij_(int_4 *,float *,float *,int_4 *,int_4 *);
-float hxy_(int_4 *,float *,float *);
+void hscale_(int_4 *,r_4 *);
+r_4 hstati_(int_4 *,int_4 *,char *,int_4 *,int_4);
+r_4 hsum_(int_4 *);
+void hunpak_(int_4 *,r_4 *,char *,int_4 *,int_4);
+void hunpke_(int_4 *,r_4 *,char *,int_4 *,int_4);
+r_4 hx_(int_4 *,r_4 *);
+r_4 hxe_(int_4 *,r_4 *);
+r_4 hxi_(int_4 *,r_4 *,int_4 *);
+r_4 hxyij_(int_4 *,r_4 *,r_4 *,int_4 *,int_4 *);
+r_4 hxy_(int_4 *,r_4 *,r_4 *);
 
 #ifdef __cplusplus
Index: trunk/SophyaLib/HiStats/hisprof.cc
===================================================================
--- trunk/SophyaLib/HiStats/hisprof.cc	(revision 1089)
+++ trunk/SophyaLib/HiStats/hisprof.cc	(revision 1092)
@@ -31,7 +31,9 @@
   SetErrOpt(1) permet de demander de calculer l'erreur sur la moyenne.
 */
-HProf::HProf(float xMin, float xMax, int nBin, float yMin, float yMax)
+HProf::HProf(r_8 xMin, r_8 xMax, int_4 nBin, r_8 yMin, r_8 yMax)
 : Histo(xMin,xMax,nBin)
-, SumY(new double[nBin]), SumY2(new double[nBin]), SumW(new double[nBin])
+, SumY( (nBin>0) ? new r_8[nBin] : NULL)
+, SumY2((nBin>0) ? new r_8[nBin] : NULL)
+, SumW( (nBin>0) ? new r_8[nBin] : NULL)
 , Ok(false), YMin(yMin), YMax(yMax), Opt(0)
 {
@@ -43,17 +45,33 @@
 /********* Methode *********/
 /*!
+  Constructeur.
+*/
+HProf::HProf(r_4 xMin, r_4 xMax, int_4 nBin, r_4 yMin, r_4 yMax)
+: Histo((r_8)xMin,(r_8)xMax,nBin)
+, SumY( (nBin>0) ? new r_8[nBin] : NULL)
+, SumY2((nBin>0) ? new r_8[nBin] : NULL)
+, SumW( (nBin>0) ? new r_8[nBin] : NULL)
+, Ok(false), YMin((r_8)yMin), YMax((r_8)yMax), Opt(0)
+{
+  Histo::Errors();
+  Zero();
+  END_CONSTRUCTOR
+}
+
+/********* Methode *********/
+/*!
   Constructeur par copie.
 */
 HProf::HProf(const HProf& H)
 : Histo(H)
-, SumY((H.bins>0)  ? new double[H.bins] : NULL)
-, SumY2((H.bins>0) ? new double[H.bins] : NULL)
-, SumW((H.bins>0)  ? new double[H.bins] : NULL)
+, SumY((H.mBins>0)  ? new r_8[H.mBins] : NULL)
+, SumY2((H.mBins>0) ? new r_8[H.mBins] : NULL)
+, SumW((H.mBins>0)  ? new r_8[H.mBins] : NULL)
 , Ok(H.Ok), YMin(H.YMin), YMax(H.YMax), Opt(H.Opt)
 {
-  if(bins>0) {
-    memcpy(SumY,  H.SumY,  bins*sizeof(double));
-    memcpy(SumY2, H.SumY2, bins*sizeof(double));
-    memcpy(SumW,  H.SumW,  bins*sizeof(double));
+  if(mBins>0) {
+    memcpy(SumY,  H.SumY,  mBins*sizeof(r_8));
+    memcpy(SumY2, H.SumY2, mBins*sizeof(r_8));
+    memcpy(SumW,  H.SumW,  mBins*sizeof(r_8));
   }
   UpdateHisto();
@@ -88,7 +106,7 @@
 void HProf::Zero()
 {
-  memset(SumY,  0, bins*sizeof(double));
-  memset(SumY2, 0, bins*sizeof(double));
-  memset(SumW,  0, bins*sizeof(double));
+  memset(SumY,  0, mBins*sizeof(r_8));
+  memset(SumY2, 0, mBins*sizeof(r_8));
+  memset(SumW,  0, mBins*sizeof(r_8));
   Ok = false;
   Histo::Zero();
@@ -112,5 +130,5 @@
 void HProf::SetErrOpt(bool spread)
 {
-int opt = (spread) ? 0 : 1;
+uint_2 opt = (spread) ? 0 : 1;
 if(opt!=Opt) {Opt=opt; Ok=false;}
 }
@@ -130,6 +148,6 @@
 void HProf::updatehisto() const
 {
-float m,e2;
-if(bins>0) for(int i=0;i<bins;i++) {
+r_8 m,e2;
+if(mBins>0) for(int_4 i=0;i<mBins;i++) {
   if(SumW[i]<=0.) {
     m = e2 = 0.;
@@ -139,6 +157,6 @@
     if(Opt) e2 /= SumW[i];
   }
-  data[i] = m;
-  err2[i] = e2;
+  mData[i] = m;
+  mErr2[i] = e2;
 }
 Ok = true;
@@ -153,10 +171,10 @@
   Addition au contenu de l'histo pour abscisse x de la valeur y et poids w
 */
-void HProf::Add(float x, float y, float w)
+void HProf::Add(r_8 x, r_8 y, r_8 w)
 {
   if(YMax>YMin && (y<YMin || YMax<y)) return;
-  int numBin = FindBin(x);
-  if (numBin<0) under += w;
-  else if (numBin>=bins) over += w;
+  int_4 numBin = FindBin(x);
+  if (numBin<0) mUnder += w;
+  else if (numBin>=mBins) mOver += w;
   else {
     Ok = false;
@@ -173,9 +191,9 @@
   Addition au contenu de l'histo bin numBin de la valeur y poids w
 */
-void HProf::AddBin(int numBin, float y, float w)
+void HProf::AddBin(int_4 numBin, r_8 y, r_8 w)
 {
   if(YMax>YMin && (y<YMin || YMax<y)) return;
-  if (numBin<0) under += w;
-  else if (numBin>=bins) over += w;
+  if (numBin<0) mUnder += w;
+  else if (numBin>=mBins) mOver += w;
   else {
     Ok = false;
@@ -195,13 +213,13 @@
 {
 if(this == &h) return *this;
-if( h.bins > bins ) Delete();
+if( h.mBins > mBins ) Delete();
 Histo *hthis = (Histo *) this;
 *hthis = (Histo) h;
-if(!SumY)  SumY  = new double[bins];
-if(!SumY2) SumY2 = new double[bins];
-if(!SumW)  SumW  = new double[bins];
-memcpy(SumY,  h.SumY,  bins*sizeof(double));
-memcpy(SumY2, h.SumY2, bins*sizeof(double));
-memcpy(SumW,  h.SumW,  bins*sizeof(double));
+if(!SumY)  SumY  = new r_8[mBins];
+if(!SumY2) SumY2 = new r_8[mBins];
+if(!SumW)  SumW  = new r_8[mBins];
+memcpy(SumY,  h.SumY,  mBins*sizeof(r_8));
+memcpy(SumY2, h.SumY2, mBins*sizeof(r_8));
+memcpy(SumW,  h.SumW,  mBins*sizeof(r_8));
 Ok = h.Ok;
 YMin = h.YMin;
@@ -222,8 +240,8 @@
 HProf& HProf::operator += (const HProf& a)
 {
-if(bins!=a.bins) THROW(sizeMismatchErr);
+if(mBins!=a.mBins) THROW(sizeMismatchErr);
 Histo *hthis = (Histo *) this;
 *hthis += (Histo) a;
-if(bins>0) for(int i=0;i<bins;i++) {
+if(mBins>0) for(int_4 i=0;i<mBins;i++) {
   SumY[i]  += a.SumY[i];
   SumY2[i] += a.SumY2[i];
@@ -239,7 +257,7 @@
   Pour rebinner l'histogramme de profile sur nbinew bins
 */
-void HProf::HRebin(int nbinew)
-{
-  if( bins <= 0 ) return; // createur par default
+void HProf::HRebin(int_4 nbinew)
+{
+  if( mBins <= 0 ) return; // createur par default
   if( nbinew <= 0 ) return;
 
@@ -248,23 +266,23 @@
 
   // Rebin de la partie Histo
-  int binold = bins;
+  int_4 binold = mBins;
   Histo::HRebin(nbinew);
 
   // Le nombre de bins est il plus grand ??
-  if( bins > binold ) {
-    delete [] SumY;  SumY  = new double[nbinew]; memset(SumY, 0,bins*sizeof(double));
-    delete [] SumY2; SumY2 = new double[nbinew]; memset(SumY2,0,bins*sizeof(double));
-    delete [] SumW;  SumW  = new double[nbinew]; memset(SumW, 0,bins*sizeof(double));
+  if( mBins > binold ) {
+    delete [] SumY;  SumY  = new r_8[nbinew]; memset(SumY, 0,mBins*sizeof(r_8));
+    delete [] SumY2; SumY2 = new r_8[nbinew]; memset(SumY2,0,mBins*sizeof(r_8));
+    delete [] SumW;  SumW  = new r_8[nbinew]; memset(SumW, 0,mBins*sizeof(r_8));
   }
 
   // Remplissage des parties propres au HPprof
-  for(int i=0;i<bins;i++) {
-    float xmi = BinLowEdge(i);
-    float xma = BinHighEdge(i);
-    int imi =  H.FindBin(xmi);
+  for(int_4 i=0;i<mBins;i++) {
+    r_8 xmi = BinLowEdge(i);
+    r_8 xma = BinHighEdge(i);
+    int_4 imi =  H.FindBin(xmi);
     if( imi < 0 ) imi = 0;
-    int ima =  H.FindBin(xma);
-    if( ima >= H.bins ) ima = H.bins-1;
-    double wY = 0., wY2 = 0., wW = 0.;
+    int_4 ima =  H.FindBin(xma);
+    if( ima >= H.mBins ) ima = H.mBins-1;
+    r_8 wY = 0., wY2 = 0., wW = 0.;
     if( ima == imi ) {
       wY  = H.SumY[imi]  * binWidth/H.binWidth;
@@ -278,5 +296,5 @@
       wW  += H.SumW[imi]  * (H.BinHighEdge(imi)-xmi)/H.binWidth;
       wW  += H.SumW[ima]  * (xma -H.BinLowEdge(ima))/H.binWidth;
-      if(ima>imi+1) for(int ii=imi+1;ii<ima;ii++)
+      if(ima>imi+1) for(int_4 ii=imi+1;ii<ima;ii++)
 	{wY += H.SumY[ii]; wY2 += H.SumY2[ii]; wW += H.SumW[ii];}
     }
@@ -305,5 +323,5 @@
 
 // Lecture des valeurs
-is.Get(dobj->bins);
+is.Get(dobj->mBins);
 is.Get(dobj->YMin);
 is.Get(dobj->YMax);
@@ -313,10 +331,10 @@
 // Lecture des donnees propres a l'histogramme de profil.
 is.GetLine(strg,255);
-dobj->SumY  = new double[dobj->bins];
-dobj->SumY2 = new double[dobj->bins];
-dobj->SumW  = new double[dobj->bins];
-is.Get(dobj->SumY,  dobj->bins);
-is.Get(dobj->SumY2, dobj->bins);
-is.Get(dobj->SumW,  dobj->bins);
+dobj->SumY  = new r_8[dobj->mBins];
+dobj->SumY2 = new r_8[dobj->mBins];
+dobj->SumW  = new r_8[dobj->mBins];
+is.Get(dobj->SumY,  dobj->mBins);
+is.Get(dobj->SumY2, dobj->mBins);
+is.Get(dobj->SumW,  dobj->mBins);
 
 // Lecture de l'histogramme
@@ -337,5 +355,5 @@
 
 // Ecriture des valeurs
-os.Put(dobj->bins);
+os.Put(dobj->mBins);
 os.Put(dobj->YMin);
 os.Put(dobj->YMax);
@@ -345,7 +363,7 @@
 sprintf(strg,"HProf: SumY SumY2 SumW");
 os.PutLine(strg);
-os.Put(dobj->SumY,  dobj->bins);
-os.Put(dobj->SumY2, dobj->bins);
-os.Put(dobj->SumW,  dobj->bins);
+os.Put(dobj->SumY,  dobj->mBins);
+os.Put(dobj->SumY2, dobj->mBins);
+os.Put(dobj->SumW,  dobj->mBins);
 
 // Ecriture de l'histogramme
Index: trunk/SophyaLib/HiStats/hisprof.h
===================================================================
--- trunk/SophyaLib/HiStats/hisprof.h	(revision 1089)
+++ trunk/SophyaLib/HiStats/hisprof.h	(revision 1092)
@@ -17,5 +17,6 @@
   // CREATOR / DESTRUCTOR
   HProf();
-  HProf(float xMin, float xMax, int nBin=100, float yMin=1., float yMax=-1.);
+  HProf(r_8 xMin, r_8 xMax, int_4 nBin=100, r_8 yMin=1., r_8 yMax=-1.);
+  HProf(r_4 xMin, r_4 xMax, int_4 nBin=100, r_4 yMin=1., r_4 yMax=-1.);
   HProf(const HProf& H);
   virtual ~HProf();
@@ -27,6 +28,6 @@
   void SetErrOpt(bool spread = true);
   void Zero();
-  void Add(float x, float y, float w = 1.);
-  void AddBin(int numBin, float y, float w = 1.);
+  void Add(r_8 x, r_8 y, r_8 w = 1.);
+  void AddBin(int_4 numBin, r_8 y, r_8 w = 1.);
   
   // Acces a l information
@@ -44,13 +45,13 @@
               {UpdateHisto(); Histo::GetError(v);}
   //! Retourne le contenu du bin i
-  inline float operator()(int i) const
-               {UpdateHisto(); return data[i];}
+  inline r_8 operator()(int_4 i) const
+               {UpdateHisto(); return mData[i];}
   //! Retourne le carre de la dispersion/erreur du bin i
-  inline double Error2(int i) const
-                {UpdateHisto(); return (float) err2[i];}
+  inline r_8 Error2(int_4 i) const
+                {UpdateHisto(); return mErr2[i];}
   //! Retourne la dispersion/erreur du bin i
-  inline float Error(int i) const
+  inline r_8 Error(int_4 i) const
                {UpdateHisto();
-                return (err2[i]>0.) ? (float) sqrt(err2[i]) : 0.f;}
+                return (mErr2[i]>0.) ? sqrt(mErr2[i]) : 0.;}
 
   // Operators
@@ -59,9 +60,9 @@
 
   // Info, statistique et calculs sur les histogrammes
-  virtual void HRebin(int nbinew);
+  virtual void HRebin(int_4 nbinew);
 
   // Fit
   //! Fit du profile par ``gfit''.
-  inline int Fit(GeneralFit& gfit)
+  inline int_4 Fit(GeneralFit& gfit)
          {UpdateHisto(); return Histo::Fit(gfit,0);}
   //! Retourne l'Histogramme des residus par ``gfit''.
@@ -74,10 +75,10 @@
   // Print
   //! Print, voir detail dans Histo::Print
-  inline void Print(int dyn=100,float hmin=1.,float hmax=-1.
-                   ,int pflag=0,int il=1,int ih=-1)
+  inline void Print(int_4 dyn=100,r_8 hmin=1.,r_8 hmax=-1.
+                   ,int_4 pflag=0,int_4 il=1,int_4 ih=-1)
          {UpdateHisto(); Histo::Print(dyn,hmin,hmax,pflag,il,ih);}
   //! PrintF, voir detail dans Histo::PrintF
-  inline void PrintF(FILE * fp,int dyn=100,float hmin=1.,float hmax=-1.
-                    ,int pflag=0,int il=1,int ih=-1)
+  inline void PrintF(FILE * fp,int_4 dyn=100,r_8 hmin=1.,r_8 hmax=-1.
+                    ,int_4 pflag=0,int_4 il=1,int_4 ih=-1)
          {UpdateHisto(); Histo::PrintF(fp,dyn,hmin,hmax,pflag,il,ih);}
 
@@ -86,11 +87,11 @@
   void updatehisto() const;
 
-  double*        SumY;  //!< somme
-  double*        SumY2; //!< somme des carres
-  double*        SumW;  //!< somme des poids
-  mutable bool   Ok;    //!< true if update fait
-  float          YMin;  //!< limite minimum Y pour somme
-  float          YMax;  //!< limite maximum Y pour somme
-  uint_2         Opt;   //!< options pour les erreurs
+  r_8*         SumY;  //!< somme
+  r_8*         SumY2; //!< somme des carres
+  r_8*         SumW;  //!< somme des poids
+  mutable bool Ok;    //!< true if update fait
+  r_8          YMin;  //!< limite minimum Y pour somme
+  r_8          YMax;  //!< limite maximum Y pour somme
+  uint_2       Opt;   //!< options pour les erreurs
 };
 
